*(1) Create SPSS version of CO weights file
*(match file command doesn't work well with temporary files)

*[Note: filenames based on running syntax from folder CO_Dummy/Data/Original Survey]

*(a) Import csv data

GET DATA  /TYPE = TXT
 /FILE = '..\..\Weights\Dummy\Dummy_wgts_v1.csv'
 /DELCASE = LINE
 /DELIMITERS = ","
 /ARRANGEMENT = DELIMITED
 /FIRSTCASE = 2
 /IMPORTCASE = ALL
 /VARIABLES =
 HH_ID F12.0
 wt_Area_1 F10.0
 wt_Area_2 F10.0
 wt_Area_3 F10.0
 wt_Area_4 F10.0
 wt_Area_5 F10.0
 wt_Area_6 F10.0
 wt_Area_7 F10.0
 wt_Area_8 F10.0
 wt_Area_9 F10.0
 wt_Area_10 F10.0
 .
EXECUTE.

DATASET NAME DataSet1.

*(b) Sort cases by HH_ID to allow match with original survey data

SORT CASES BY HH_ID (A)

*(c) Save file

*SAVE OUTFILE='..\..\Weights\Dummy_wgts_v1.sav'
*/COMPRESSED.


*(2) Open original survey data and make active SPSS dataset

GET FILE='CO_Dummy_survey.sav'.
DATASET NAME DataSet2.

*(3) Sort original survey sorted by (i) HH_ID; (ii) persons within household
*    (Otherwise matching with CO weights will fail)

SORT CASES BY HH_ID (A) Person (A) .

*(4) Merge weights with survey data

DATASET ACTIVATE DataSet2.

MATCH FILES /FILE=*
 /TABLE='DataSet1'
 /BY HH_ID.
EXECUTE.

DATASET CLOSE DataSet1.

*(5) Reproduce constraint tables using CO weights

*(a) Recode variables to match constraint table categories

*(i) Age

RECODE  Age  (0 thru 15=1)  (16 thru 64=2)  (65 thru Highest=3)  INTO  Age_gp .
VARIABLE LABELS Age_gp 'Grouped Age'.
VALUE LABELS Age_gp 1 'Child' 2 'Adult' 3 'Pensioner'.
EXECUTE .

*(ii) Sex [already in required format]
*(iii) Cars [already in required format]
*(iv) HH_Size [already in required format]


*(b) Reweight survey using chosen set of CO area weights

WEIGHT BY wt_Area_1.

*(c) Reproduce constraint tabulations

*(i) Table P1 (Person-level)

CROSSTABS
  /TABLES=Age_gp BY Sex
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT
  /COUNT ROUND CELL .

*(ii) Table H1 (Household-level)
*[FILTER BY FIRST PERSON IN HOUSEHOLD TO PRODUCE HOUSEHOLD COUNTS]

COMPUTE Household_Filter=(Person=1).
VARIABLE LABEL Household_Filter 'Household Filter'.
VALUE LABELS Household_Filter  0 'Not Selected' 1 'Selected'.
FORMAT Household_Filter (f1.0).
FILTER BY Household_Filter.
EXECUTE .

CROSSTABS
  /TABLES=Cars  BY HH_Size
  /FORMAT= AVALUE TABLES
  /CELLS= COUNT
  /COUNT ROUND CELL .

FILTER OFF.
USE ALL.


